#ifndef MENU_MANAGER_H
#define MENU_MANAGER_H

#include <pgapplication.h>
#include <pgthemewidget.h>

#include "Tools.h"
#include "GuiException.h"
#include "MenuIds.h"

class Menu;

class MenuManager
{
  public:

    static void init(Sint16 w, Sint16 h, Uint8 d, Sint32 f,
        const char* layout, const char* theme)
      throw(Exception);

    static void destroy();

    static MenuManager* getInstance()
      throw(GuiException);

    void changeTo(Menu* menu, bool background = true, bool overridePrevious = true);
    void hideAll() throw(Exception);
    void redrawBackground();

    static PG_Widget* getWidgetById(int id) throw(GuiMenuException);

  protected:

    MenuManager();
    MenuManager(MenuManager&);
    virtual ~MenuManager();
    void check(PG_Widget* w, int id) throw(GuiException);

    static MenuManager* sm_instance;

    PG_Application* m_app;

    Menu* m_current;
    PG_ThemeWidget *m_background;
};

#endif // MENU_MANAGER_H
