#include <pgimage.h>

#include "Configuration.h"
#include "Ship.h"
#include "PlayerConfiguration.h"

#include "PlayerMenu.h"


MENU_SINGLETON_INIT(Player);

//----------------------------------------------------------------------
PlayerMenu::PlayerMenu() throw(GuiMenuException)
{
  getWidget(ID_PLAYER_MENU_OK)->SetEventObject(
    MSG_BUTTONCLICK, this, (MSG_CALLBACK_OBJ)&PlayerMenu::onOk);
  getWidget(ID_PLAYER_MENU_CANCEL)->SetEventObject(
    MSG_BUTTONCLICK, this, (MSG_CALLBACK_OBJ)&PlayerMenu::onCancel);
  
    getWidget(ID_PLAYER_MENU_OK)->Show();
    getWidget(ID_PLAYER_MENU_CANCEL)->Show();
    getWidget(ID_PLAYER_MENU_NAMELAB)->Show();
    getWidget(ID_PLAYER_MENU_NAMEEDIT)->Show();
    getWidget(ID_PLAYER_MENU_SHIPLAB)->Show();
    getWidget(ID_PLAYER_MENU_SHIPSEL)->Show();
}

//----------------------------------------------------------------------
PlayerMenu::~PlayerMenu()
{
}

//----------------------------------------------------------------------
PARAGUI_CALLBACK(PlayerMenu::onOk)
{
    PlayerConfiguration::getInstance()->getPlayer()->setName(
        m_nameEdit->GetText());
    PlayerConfiguration::getInstance()->writeConfiguration();

    MenuManager::getInstance()->changeTo(getPrevious(), true, false);
    return true;
}

//----------------------------------------------------------------------
PARAGUI_CALLBACK(PlayerMenu::onCancel)
{
    MenuManager::getInstance()->changeTo(getPrevious(), true, false);
    return true;
}

//----------------------------------------------------------------------
void PlayerMenu::eventShow()
{
    const std::string &name =
        PlayerConfiguration::getInstance()->getPlayer()->getName();
    ShipSurfaces::Ship shipType =
        PlayerConfiguration::getInstance()->getPlayer()->getShipType();

    PG_Widget* nameLabel = getWidget(ID_PLAYER_MENU_NAMEEDIT);
    nameLabel->RemoveAllChilds();
  
    m_nameEdit = new PG_LineEdit(
        nameLabel, 
        PG_Rect(0, 0, nameLabel->Width(), nameLabel->Height()),
        "LabelEdit",
        128);
    m_nameEdit->SetFontSize(nameLabel->GetFontSize());
    m_nameEdit->SetText(name.c_str());
    m_nameEdit->Show();
    nameLabel->AddChild(m_nameEdit);

    PG_Widget* shipLabel = getWidget(ID_PLAYER_MENU_SHIPSEL);
    shipLabel->RemoveAllChilds();
    PG_Point pos = {0,0};
    PG_Image* shipImage = new PG_Image(
        shipLabel, pos,
        const_cast<SDL_Surface*>(
            ShipSurfaces::getInstance()->getSurface(shipType, 0)),
        false);
    shipImage->SetTransparency(0);
    shipImage->Show();

    getWidget(ID_PLAYER_MENU)->Show();
}

//----------------------------------------------------------------------
void PlayerMenu::eventHide()
{
  getWidget(ID_PLAYER_MENU)->Hide();
}

